//+------------------------------------------------------------------+
//|                                                 Advanced_ADX.mq4 |
//|                              Copyright  2006, Eng. Waddah Attar |
//|                                          waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Waddah Attar"
#property link      "waddahattar@hotmail.com"
//----
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
//----
extern int ADXPeriod = 3;
extern int BarWidth = 1;
extern bool SignalOnClosedCandle = false;
extern double ExitLevel = 90,
            RangeLevel = 40;
extern bool AlertOn = true;
extern bool EmailOn = true;
extern int  Corner = 1;
extern bool ShowOnMainWindow=true;            
extern color TrendColor=Gold,
             TrendStartColor=Lime,
             ExitColor=Red,
             RangeColor=Aqua;
             
//----
double ExtBuffer1[];
double ExtBuffer2[];
int SignalCandle=0,Trend=-1;
string IndicatorName="";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit() {
   ObjectDelete("Trade");
}
int init() {
   ObjectDelete("Trade");
   SetIndexBuffer(0, ExtBuffer1);
   SetIndexStyle(0, DRAW_HISTOGRAM, 0, BarWidth);
//----
   SetIndexBuffer(1, ExtBuffer2);
   SetIndexStyle(1, DRAW_HISTOGRAM, 0, BarWidth);
//----
   IndicatorName="Advanced_ADX (" + ADXPeriod + ")";
   IndicatorShortName(IndicatorName);
   SetLevelValue(0,ExitLevel);
   SetLevelValue(1,RangeLevel);
   if (SignalOnClosedCandle) SignalCandle=1;
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i, limit;
   double ADX0,ADX1,ADX2;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars; 
//----   
   for(i = 0; i < limit ; i++)
     {
       ADX0 = iADX(NULL, 0, ADXPeriod, PRICE_CLOSE, MODE_MAIN, i);
       ADX1 = iADX(NULL, 0, ADXPeriod, PRICE_CLOSE, MODE_PLUSDI, i);
       ADX2 = iADX(NULL, 0, ADXPeriod, PRICE_CLOSE, MODE_MINUSDI, i);
       //----
       if(ADX1 >= ADX2)
         {
           ExtBuffer1[i] = ADX0;
           ExtBuffer2[i] = 0;
         }
       else
         {
           ExtBuffer1[i] = 0;
           ExtBuffer2[i] = ADX0;
         }
     }
   double adx = MathMax(ExtBuffer1[SignalCandle],ExtBuffer2[SignalCandle]);
   double adx1 = MathMax(ExtBuffer1[SignalCandle+1],ExtBuffer2[SignalCandle+1]);
   string OPstr;
   color OPclr;
   if (adx>ExitLevel) {
      Trend=3;
      OPstr="TRENDING";
      OPclr=TrendColor;
      }
   else if (adx<ExitLevel && adx1>=ExitLevel) {
      OPstr="EXIT CURRENT POSITION";
      OPclr=ExitColor;
      }
  else if (adx<=ExitLevel && adx>RangeLevel) {
      OPstr="TREND IN PLACE";
      OPclr=TrendStartColor;
      }
   else if (adx<=RangeLevel) {
      OPstr="STAY OUT - MARKET IN RANGE";
      OPclr=RangeColor;
      }
   if (adx<ExitLevel && adx1>=ExitLevel && Trend!=2) {
      Trend=2;
      if (AlertOn) Alert("ADX Exit Current Position - "+Symbol()+"["+Period()+"m]");
      if (EmailOn) SendMail("ADX Exit Current Position","Exit position on "+Symbol()+"["+Period()+"m]");
      }
   else if (adx>RangeLevel && adx1<=RangeLevel && Trend!=1) {
      Trend=1;
      if (AlertOn) Alert("ADX Trend In Place - "+Symbol()+"["+Period()+"m]");
      if (EmailOn) SendMail("ADX Trend In Place","Trend in place on "+Symbol()+"["+Period()+"m]");
      }
   else if (adx<RangeLevel && adx1>=RangeLevel && Trend!=0) {
      Trend=0;
      if (AlertOn) Alert("ADX Stay Out - Market In Range - "+Symbol()+"["+Period()+"m]");
      if (EmailOn) SendMail("ADX Stay Out - Market In Range","Market in range on "+Symbol()+"["+Period()+"m]");
      }
   if (ShowOnMainWindow) {
      ObjectCreate("Trade", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Trade", OPstr, 12, "Arial Narrow", OPclr);
      ObjectSet("Trade", OBJPROP_CORNER, Corner);
      ObjectSet("Trade", OBJPROP_XDISTANCE, 20);
      ObjectSet("Trade", OBJPROP_YDISTANCE, 20);
      }
   else {
      ObjectCreate("Trade", OBJ_LABEL, WindowFind(IndicatorName), 0, 0);
      ObjectSetText("Trade", OPstr, 12, "Arial Narrow", OPclr);
      ObjectSet("Trade", OBJPROP_CORNER, Corner);
      ObjectSet("Trade", OBJPROP_XDISTANCE, 10);
      ObjectSet("Trade", OBJPROP_YDISTANCE, 3);
      }
   
   return(0);
  }
//+------------------------------------------------------------------+

